import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { FaTable } from 'react-icons/fa';
import { FaChartBar } from 'react-icons/fa';
import { FaArrowAltCircleRight } from 'react-icons/fa';
import { FaFileExcel } from 'react-icons/fa';
import { FaFilter } from 'react-icons/fa';
import { formatValue, convertValueTimeParameter } from '../common/utils.js';
var ChartTitle = function (_a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    var setup = _a.setup, onToggleView = _a.onToggleView, handleLinkChart = _a.handleLinkChart, handleDownloadExcel = _a.handleDownloadExcel, onShowFilter = _a.onShowFilter, appliedFilters = _a.appliedFilters;
    var _p = React.useState('chart'), viewMode = _p[0], setViewMode = _p[1];
    var _q = React.useState(''), filterDescription = _q[0], setFilterDescription = _q[1];
    function changeViewData(event) {
        event.stopPropagation();
        var newViewMode = viewMode === 'chart' ? 'table' : 'chart';
        setViewMode(newViewMode);
        onToggleView(newViewMode === 'table');
    }
    function nextDashboard(event) {
        var _a;
        event.stopPropagation();
        var chartLink = ((_a = setup.chart) === null || _a === void 0 ? void 0 : _a.chart_link) || setup.link;
        if (chartLink && chartLink.length > 0) {
            return handleLinkChart({
                setup: setup,
                chart_link: chartLink,
                filter: appliedFilters,
            });
        }
    }
    function downloadFileExcel(event) {
        event.stopPropagation();
        return handleDownloadExcel();
    }
    function showFilter(event) {
        event.stopPropagation();
        onShowFilter();
    }
    var hasDefaultParameters = function (parameters) {
        if (!Array.isArray(parameters))
            return false;
        return parameters.some(function (param) {
            var defaultValue = param === null || param === void 0 ? void 0 : param.default;
            return defaultValue !== undefined && defaultValue !== null && defaultValue !== '';
        });
    };
    React.useEffect(function () {
        var subTitle = setup.sub_title;
        if (!subTitle)
            return;
        var formattedSubTitle = subTitle.replace(/\{\{\w+(:[^}]*)?\}\}/g, function (match) {
            var textMatch = match.substring(2, match.length - 2);
            var _a = textMatch.split(':'), code = _a[0], _b = _a[1], format = _b === void 0 ? '' : _b;
            var rawValue = appliedFilters === null || appliedFilters === void 0 ? void 0 : appliedFilters[code];
            if (!rawValue && setup.parameters) {
                var parameter = setup.parameters.find(function (param) { return (param === null || param === void 0 ? void 0 : param.code) === code; });
                if (parameter === null || parameter === void 0 ? void 0 : parameter.default) {
                    rawValue = convertValueTimeParameter(parameter.default);
                }
            }
            return format ? formatValue(rawValue, format) || '' : rawValue || '';
        });
        setFilterDescription(formattedSubTitle || '');
    }, [appliedFilters, setup.sub_title]);
    return (_jsxs("div", { className: "s-dashboard__title", style: {
            display: 'flex',
            justifyContent: 'space-between',
            alignItems: 'center',
        }, children: [_jsxs("div", { className: "s-dashboard__title--text", style: { overflow: 'hidden', whiteSpace: 'nowrap', textOverflow: 'ellipsis' }, children: [_jsx("p", { className: "s-dashboard__title--header", style: {
                            overflow: 'hidden',
                            whiteSpace: 'nowrap',
                            textOverflow: 'ellipsis',
                            color: ((_d = (_c = (_b = setup.chart) === null || _b === void 0 ? void 0 : _b.title) === null || _c === void 0 ? void 0 : _c.textStyle) === null || _d === void 0 ? void 0 : _d.color) || '#000',
                            fontSize: ((_g = (_f = (_e = setup.chart) === null || _e === void 0 ? void 0 : _e.title) === null || _f === void 0 ? void 0 : _f.textStyle) === null || _g === void 0 ? void 0 : _g.fontSize) || 14,
                            display: ((_j = (_h = setup.chart) === null || _h === void 0 ? void 0 : _h.title) === null || _j === void 0 ? void 0 : _j.show) ? 'block' : 'none',
                        }, children: ((_m = (_l = (_k = setup.chart) === null || _k === void 0 ? void 0 : _k.title) === null || _l === void 0 ? void 0 : _l.text) === null || _m === void 0 ? void 0 : _m.trim()) || setup.title || '' }), (Object.keys(appliedFilters !== null && appliedFilters !== void 0 ? appliedFilters : {}).length > 0 ||
                        hasDefaultParameters(setup.parameters)) &&
                        setup.sub_title && (_jsx("div", { className: "s-dashboard__title--sub", style: {
                            fontSize: '12px',
                            color: '#666',
                        }, children: filterDescription }))] }), _jsxs("div", { className: "s-dashboard__title--icons", children: [(viewMode === 'table' || setup.type === 'table') && (_jsx("div", { className: "s-dashboard-icon download-data-excel", children: _jsx(FaFileExcel, { size: 35, onClick: downloadFileExcel }) })), setup.table && setup.type !== 'table' && (_jsx("div", { className: "s-dashboard-icon", onClick: changeViewData, children: viewMode === 'chart' ? _jsx(FaTable, { size: 35 }) : _jsx(FaChartBar, { size: 35 }) })), setup.parameters && setup.parameters.length > 0 && (_jsx("div", { className: "s-dashboard-icon filter", children: _jsx(FaFilter, { size: 35, onClick: showFilter }) })), ((((_o = setup.chart) === null || _o === void 0 ? void 0 : _o.chart_link) && setup.chart.chart_link.length > 0) || (setup.link && setup.link.length > 0)) && (_jsx("div", { className: "s-dashboard-icon next-dashboard", children: _jsx(FaArrowAltCircleRight, { size: 35, onClick: nextDashboard }) }))] })] }));
};
export default ChartTitle;
